unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, unGHFort,  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    RegPath: string;
  end;

var
  Form1          : TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  //setting vectors for our DEMO application
  unGHFort.ApplicationNo := 100000;
  unGHFort.SerialArray[0] := 10;
  unGHFort.SerialArray[1] := 15;
  unGHFort.SerialArray[2] := 19;
  unGHFort.SerialArray[3] := 21;
  unGHFort.SerialArray[4] := 17;
  unGHFort.SerialArray[5] := 34;
  unGHFort.SerialArray[6] := 25;
  unGHFort.SerialArray[7] := 16;
  unGHFort.SerialArray[8] := 9;
  unGHFort.SerialArray[9] := 29;
  unGHFort.SerialArray[10] := 8;

  RegPath := 'Software\Green House\Test\';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  s:string;
begin
  s:=GetCodeIdent;
  if length(s)<>11 then raise Exception.Create('Error, probably not running in the IDE');
  ShowMessage(s + #13#10#13#10 +
    'Use this code to generate serial number with Key Generator');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if ValidSerial(RegPath) then ShowMessage('Registered') else ShowMessage('Unregistered');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SetSerial(inputBox('Registration', 'Input registration code', ''), RegPath);
end;

end.

 