{
-----------------------------------------------------------------------
   Unit        : unGHFort
   Author      : Emil Beli
   Created     : 17 SEP 2003

   OBJECTIVE   : Piracy protection
   
    Copyright Green House multimedia, 2003
------------------------------------------------------------------------

 HOW IT WORKS:
 -------------
   There are three main methods that will be used for making
 your protection work. All three uses GHCrUtils.dll which must be located in
 windows system directory.
   Well, you can put it elsewhere, but you need to alter a code a bit. It is
 very easy.

   User of your application must provide you with the unique identification code.
 You will obtain it by calling GetCodeIdent function.
   User will send that code to you and you will generate it with your key generator,
 and send it back to him.
   He will enter that code in some edit box and you will save it with
 SetSerial procedure.
   To verify if user is registered, you will use ValidSerial function that will
 return you TRUE if registered or FALSE if not.

   More info about implementation and security measures in the help file.
}

unit unGHFort;

interface
uses classes, windows, Sysutils;

type
  TVector = 1..40;
  TSerialArray = array[0..10] of TVector;

function GetSysDir: string;

// MAIN METHODS (DLL wrapper)
function GetCodeIdent: string;
function ValidSerial(RegPath: string): boolean;
procedure SetSerial(Serial, RegPath: string);

var
  ApplicationNo     : DWord;
  SerialArray       : TSerialArray;

implementation

function GetSysDir: string;
  function CheckLastChar(Value: string): string;
  begin
    if (Length(Value) > 0) and (Value[Length(Value)] <> '\') then
      Value := Value + '\';
    Result := Value;
  end;
var
  Buffer            : array[0..MAX_PATH] of Char;
begin
  Windows.GetSystemDirectory(Buffer, SizeOf(Buffer));
  Result := CheckLastChar(Buffer);
end;

function GetCodeIdent: string;
type
  TProc = function(AppNo: DWord): PChar; stdcall;
  TAuth = procedure(Code: integer); stdcall;
var
  Hndl              : THandle;
  Proc              : TProc;
  Auth              : TAuth;
begin
  Hndl := LoadLibrary(PChar(GetSysDir + 'GHCrUtils.dll'));
  if Hndl > 0 then
  begin
    @auth := GetProcAddress(Hndl, 'SetAuthorization');
    if @auth <> nil then auth(735241);
    @Proc := GetProcAddress(Hndl, 'GetCodeIdent');
    if @Proc <> nil then result := StrPas(Proc(ApplicationNo));
    FreeLibrary(Hndl);
  end;
end;

function ValidSerial(RegPath: string): boolean;
type
  TProc = function(ARegPath: PChar; ApplicationNo: DWord; SerialArray: TSerialArray): Boolean; stdcall;
  TAuth = procedure(Code: integer); stdcall;
var
  Hndl              : THandle;
  Proc              : TProc;
  Auth              : TAuth;
begin
  result := false;
  Hndl := LoadLibrary(PChar(GetSysDir + 'GHCrUtils.dll'));
  if Hndl > 0 then
  begin
    @auth := GetProcAddress(Hndl, 'SetAuthorization');
    if @auth <> nil then auth(735241);
    @Proc := GetProcAddress(Hndl, 'isValidSN');
    if @Proc <> nil then
      result := Proc(PChar(RegPath), ApplicationNo, SerialArray);
    FreeLibrary(Hndl);
  end;
end;

procedure SetSerial(Serial, RegPath: string);
type
  TProc = procedure(Serial, RegPath: PChar); stdcall;
  TAuth = procedure(Code: integer); stdcall;
var
  Hndl              : THandle;
  Proc              : TProc;
  Auth              : TAuth;
begin
  Hndl := LoadLibrary(PChar(GetSysDir + 'GHCrUtils.dll'));
  if Hndl > 0 then
  begin
    @auth := GetProcAddress(Hndl, 'SetAuthorization');
    if @auth <> nil then auth(735241);
    @Proc := GetProcAddress(Hndl, 'SetSerial');
    if @Proc <> nil then Proc(PChar(Serial), PChar(RegPath));
    FreeLibrary(Hndl);
  end;
end;

initialization
  {
     Your security starts here. Choose some ID number for your application.
     Let it be no less than 100000. Some random number, eg. 8726343,
     would be nice...

     Serial array should be filled with numbers 1-40. Make it as random as
     possible. Try not to repeat same number more than two times.
  }

  ApplicationNo := 100000;
  SerialArray[0] := 1;
  SerialArray[1] := 1;
  SerialArray[2] := 1;
  SerialArray[3] := 1;
  SerialArray[4] := 1;
  SerialArray[5] := 1;
  SerialArray[6] := 1;
  SerialArray[7] := 1;
  SerialArray[8] := 1;
  SerialArray[9] := 1;
  SerialArray[10] := 1;

end.

